Development
  • Guides
  • API Reference
  • API Explorer
  • SDKs
  • Sample apps
  • System status
Support
  • Developer forums
  • Developer blog
  • YouTube
  • X
More
  • Square Home
  • Square Developer
  • App Marketplace
  • Partner with Square
  • Solutions Partner Program
  • Pricing
  • Sales

© 2026 Square, Inc.

  • Developer terms of service
  • Developer Integration and Marketing Agreement
  • Privacy policy
  • Partnerships
  • Sign In
  • Sign In

    Labor

  • List break types

  • Create break type

  • Delete break type

  • Get break type

  • Update break type

  • Create scheduled shift

  • Bulk publish scheduled shifts

  • Search scheduled shifts

  • Retrieve scheduled shift

  • Update scheduled shift

  • Publish scheduled shift

  • List team member wages

  • Get team member wage

  • Create timecard

  • Search timecards

  • Delete timecard

  • Retrieve timecard

  • Update timecard

  • List workweek configs

  • Update workweek config

  • Webhooks

  • labor.scheduled_shift.created

  • labor.scheduled_shift.deleted

  • labor.scheduled_shift.published

  • labor.scheduled_shift.updated

  • labor.timecard.created

  • labor.timecard.deleted

  • labor.timecard.updated

<- Labor API

Labor API

All versions ->

Create scheduled shiftBeta

POST

 /v2/labor/scheduled-shifts

Creates a scheduled shift by providing draft shift details such as job ID, team member assignment, and start and end times.

The following draft_shift_details fields are required:

  • location_id
  • job_id
  • start_at
  • end_at
Permissions:TIMECARDS_WRITE

Guide

Scheduling with the Labor API

Try in API Explorer
Link to section

Request body

Example code

Link to section

idempotency_key

string

A unique identifier for the CreateScheduledShift request, used to ensure the idempotency of the operation.

Max Length
128
Link to section

scheduled_shift

Required

The scheduled shift with draft_shift_details. If needed, call ListLocations to get location IDs, ListJobs to get job IDs, and SearchTeamMembers to get team member IDs and current job assignments.

The start_at and end_at timestamps must be provided in the time zone + offset of the shift location specified in location_id. Example for Pacific Standard Time: 2024-10-31T12:30:00-08:00

Link to section

Response fields

Link to section

scheduled_shift

The new scheduled shift. To make the shift public, call PublishScheduledShift or BulkPublishScheduledShifts.

Link to section

errors

Any errors that occurred during the request.

Link to section

Examples

All versions ->

POST /v2/labor/scheduled-shifts
curl https://connect.squareup.com/v2/labor/scheduled-shifts \ -X POST \ -H 'Square-Version: 2026-11-18' \ -H 'Authorization: Bearer ACCESS_TOKEN' \ -H 'Content-Type: application/json' \ -d '{ "idempotency_key": "HIDSNG5KS478L", "scheduled_shift": { "draft_shift_details": { "team_member_id": "ormj0jJJZ5OZIzxrZYJI", "location_id": "PAA1RJZZKXBFG", "job_id": "FzbJAtt9qEWncK1BWgVCxQ6M", "start_at": "2019-01-25T03:11:00-05:00", "end_at": "2019-01-25T13:11:00-05:00", "notes": "Dont forget to prep the vegetables", "is_deleted": false } } }'

Response JSON

{ "scheduled_shift": { "id": "K0YH4CV5462JB", "draft_shift_details": { "team_member_id": "ormj0jJJZ5OZIzxrZYJI", "location_id": "PAA1RJZZKXBFG", "job_id": "FzbJAtt9qEWncK1BWgVCxQ6M", "start_at": "2019-01-25T03:11:00-05:00", "end_at": "2019-01-25T13:11:00-05:00", "notes": "Dont forget to prep the vegetables", "is_deleted": false, "timezone": "America/New_York" }, "version": 1, "created_at": "2019-02-25T03:11:00-05:00", "updated_at": "2019-02-25T03:11:00-05:00" } }